Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell

Namespace WinPhoneFtp.DemoApp

	Partial Public Class Authenticate
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Protected Overrides Sub OnNavigatingFrom(ByVal e As NavigatingCancelEventArgs)

			rdbtnAuthAnonymous.IsEnabled = True
			rdbtnAuthAnonymous.IsEnabled = True
			SystemTray.ProgressIndicator = Nothing
			MyBase.OnNavigatingFrom(e)

		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)

			Do While Me.NavigationService.CanGoBack

				Me.NavigationService.RemoveBackEntry()

			Loop

		End Sub

		Protected Overrides Sub OnBackKeyPress(ByVal e As System.ComponentModel.CancelEventArgs)

			MyBase.OnBackKeyPress(e)

		End Sub

		Private async Sub appbarbtnAuthenticate_Click(ByVal sender As Object, ByVal e As EventArgs)

			If rdbtnAuthAnonymous.IsChecked.HasValue AndAlso rdbtnAuthAnonymous.IsChecked.Value Then

				rdbtnAuthAnonymous.IsEnabled = False
				rdbtnAuthCredentials.IsEnabled = False
				rdbtnAuthCredentials.IsChecked = False
				rdbtnAuthAnonymous.IsChecked = False
				SystemTray.ProgressIndicator = New ProgressIndicator With {.IsIndeterminate = True, .Text = "Authenticating . . ."}
                Await (TryCast(App.Current, App)).Client.AuthenticateAsync
                Exit Sub

			End If

			If rdbtnAuthCredentials.IsChecked.HasValue AndAlso rdbtnAuthCredentials.IsChecked.Value Then

				rdbtnAuthAnonymous.IsEnabled = False
				rdbtnAuthCredentials.IsEnabled = False
				rdbtnAuthCredentials.IsChecked = False
				rdbtnAuthAnonymous.IsChecked = False
				SystemTray.ProgressIndicator = New ProgressIndicator With {.IsIndeterminate = True, .Text = "Authenticating . . ."}
				await (TryCast(App.Current, App)).Client.AuthenticateAsync(txtUsername.Text, pwdPassword.Password)
                Exit Sub

			End If

		End Sub

		Private Sub rdbtnAuthCredentials_Checked(ByVal sender As Object, ByVal e As RoutedEventArgs)

			txtUsername.IsEnabled = True
			pwdPassword.IsEnabled = True

		End Sub

		Private Sub rdbtnAuthCredentials_Unchecked(ByVal sender As Object, ByVal e As RoutedEventArgs)

			txtUsername.IsEnabled = False
			pwdPassword.IsEnabled = False

		End Sub

	End Class

End Namespace
