Imports System
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Threading.Tasks
Imports System.Windows
Imports Windows.Storage
Imports System.Text
Imports Windows.Storage.Streams
Imports System.Windows.Threading

Namespace WinPhoneFtp.FtpService

    Public NotInheritable Class Logger

        Private Shared s_Logger As Logger = Nothing
        Public Shared Function GetDefault(ByVal UIDispatcher As Dispatcher) As Logger

            If s_Logger Is Nothing Then

                s_Logger = New Logger(UIDispatcher)

            End If
            Return s_Logger

        End Function

        Private UIDispatcher As Dispatcher = Nothing

        Private Sub New(ByVal UIDispatcher As Dispatcher)

            Logs = New ObservableCollection(Of String)
            Me.UIDispatcher = If(UIDispatcher IsNot Nothing, UIDispatcher, Deployment.Current.Dispatcher)

        End Sub

        Private PrivateLogs As ObservableCollection(Of String)
        Public Property Logs As ObservableCollection(Of String)
            Get
                Return PrivateLogs
            End Get
            Private Set(ByVal value As ObservableCollection(Of String))
                PrivateLogs = value
            End Set
        End Property

        Public Sub AddLog(ByVal LogInfo As String)

            UIDispatcher.BeginInvoke(Sub()

                                         System.Diagnostics.Debug.WriteLine(LogInfo)
                                         Logs.Add(LogInfo)

                                     End Sub)

        End Sub

    End Class

End Namespace
