Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell

Namespace WinPhoneFtp.DemoApp

	Partial Public Class Disconnect
		Inherits PhoneApplicationPage

		Public Sub New()

			InitializeComponent()

		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)

			AddHandler TryCast(App.Current, App).Client.FtpDisconnected, AddressOf Client_FtpDisconnected
			MyBase.OnNavigatedTo(e)

		End Sub

		Private Sub Client_FtpDisconnected(ByVal sender As Object, ByVal e As FtpService.FtpDisconnectedEventArgs)

			Me.Dispatcher.BeginInvoke(Sub() Me.NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative)))

		End Sub

		Private async Sub btnDisconnect_Tap(ByVal sender As Object, ByVal e As System.Windows.Input.GestureEventArgs)

            Await (TryCast(App.Current, App)).Client.DisconnectAsync

		End Sub

	End Class

End Namespace
