Imports System
Imports System.IO

Namespace WinPhoneFtp.FtpService

    Public Class FtpFileTransferEventArgs
        Inherits EventArgs

        Friend Sub New(ByVal LocalFileStream As Stream, ByVal RemoteFile As String)

            Me.LocalFileStream = LocalFileStream
            Me.RemoteFile = RemoteFile

        End Sub

        Private PrivateLocalFileStream As Stream
        Public Property LocalFileStream As Stream
            Get
                Return PrivateLocalFileStream
            End Get
            Private Set(ByVal value As Stream)
                PrivateLocalFileStream = value
            End Set
        End Property

        Private PrivateRemoteFile As String
        Public Property RemoteFile As String
            Get
                Return PrivateRemoteFile
            End Get
            Private Set(ByVal value As String)
                PrivateRemoteFile = value
            End Set
        End Property

    End Class

End Namespace
