Imports System

Namespace WinPhoneFtp.FtpService
    Public Class SocketClosedEventArgs
        Inherits EventArgs

        Private closeReason_Renamed As SocketCloseReason = SocketCloseReason.None

        Friend Sub New(ByVal closeReason As SocketCloseReason)
            MyBase.New()
            Me.closeReason_Renamed = closeReason
        End Sub

        Public ReadOnly Property CloseReason As SocketCloseReason
            Get
                Return closeReason_Renamed
            End Get
        End Property
    End Class
End Namespace